Index: mythtv/libs/libmythhdhomerun/hdhomerun.h
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun.h	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun.h	(working copy)
@@ -3,7 +3,7 @@
 /*
  * hdhomerun.h
  *
- * Copyright © 2006-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2006-2008 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -35,7 +35,6 @@
 #include "hdhomerun_os.h"
 #include "hdhomerun_types.h"
 #include "hdhomerun_pkt.h"
-#include "hdhomerun_sock.h"
 #include "hdhomerun_debug.h"
 #include "hdhomerun_discover.h"
 #include "hdhomerun_control.h"
Index: mythtv/libs/libmythhdhomerun/hdhomerun_debug.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_debug.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_debug.c	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_debug.c
  *
- * Copyright © 2006-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2006 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -44,13 +44,9 @@
 #define HDHOMERUN_DEBUG_HOST "debug.silicondust.com"
 #endif
 #if !defined(HDHOMERUN_DEBUG_PORT)
-#define HDHOMERUN_DEBUG_PORT 8002
+#define HDHOMERUN_DEBUG_PORT "8002"
 #endif
 
-#define HDHOMERUN_DEBUG_CONNECT_RETRY_TIME 30000
-#define HDHOMERUN_DEBUG_CONNECT_TIMEOUT 10000
-#define HDHOMERUN_DEBUG_SEND_TIMEOUT 10000
-
 struct hdhomerun_debug_message_t
 {
 	struct hdhomerun_debug_message_t *next;
@@ -77,7 +73,7 @@
 
 	char *file_name;
 	FILE *file_fp;
-	hdhomerun_sock_t sock;
+	int sock;
 };
 
 static THREAD_FUNC_PREFIX hdhomerun_debug_thread_execute(void *arg);
@@ -89,7 +85,7 @@
 		return NULL;
 	}
 
-	dbg->sock = HDHOMERUN_SOCK_INVALID;
+	dbg->sock = -1;
 
 	pthread_mutex_init(&dbg->print_lock, NULL);
 	pthread_mutex_init(&dbg->queue_lock, NULL);
@@ -121,8 +117,8 @@
 	if (dbg->file_fp) {
 		fclose(dbg->file_fp);
 	}
-	if (dbg->sock != HDHOMERUN_SOCK_INVALID) {
-		hdhomerun_sock_destroy(dbg->sock);
+	if (dbg->sock != -1) {
+		close(dbg->sock);
 	}
 
 	free(dbg);
@@ -136,9 +132,9 @@
 		dbg->file_fp = NULL;
 	}
 
-	if (dbg->sock != HDHOMERUN_SOCK_INVALID) {
-		hdhomerun_sock_destroy(dbg->sock);
-		dbg->sock = HDHOMERUN_SOCK_INVALID;
+	if (dbg->sock != -1) {
+		close(dbg->sock);
+		dbg->sock = -1;
 	}
 }
 
@@ -255,7 +251,7 @@
 			return;
 		}
 
-		msleep_approx(10);
+		msleep(10);
 	}
 }
 
@@ -376,40 +372,54 @@
 }
 
 /* Send lock held by caller */
+#if defined(__CYGWIN__)
 static bool_t hdhomerun_debug_output_message_sock(struct hdhomerun_debug_t *dbg, struct hdhomerun_debug_message_t *message)
 {
-	if (dbg->sock == HDHOMERUN_SOCK_INVALID) {
+	return TRUE;
+}
+#else
+static bool_t hdhomerun_debug_output_message_sock(struct hdhomerun_debug_t *dbg, struct hdhomerun_debug_message_t *message)
+{
+	if (dbg->sock == -1) {
 		uint64_t current_time = getcurrenttime();
 		if (current_time < dbg->connect_delay) {
 			return FALSE;
 		}
-		dbg->connect_delay = current_time + HDHOMERUN_DEBUG_CONNECT_RETRY_TIME;
+		dbg->connect_delay = current_time + 30*1000;
 
-		dbg->sock = hdhomerun_sock_create_tcp();
-		if (dbg->sock == HDHOMERUN_SOCK_INVALID) {
+		dbg->sock = (int)socket(AF_INET, SOCK_STREAM, 0);
+		if (dbg->sock == -1) {
 			return FALSE;
 		}
 
-		uint32_t remote_addr = hdhomerun_sock_getaddrinfo_addr(dbg->sock, HDHOMERUN_DEBUG_HOST);
-		if (remote_addr == 0) {
+		struct addrinfo hints;
+		memset(&hints, 0, sizeof(hints));
+		hints.ai_family = AF_INET;
+		hints.ai_socktype = SOCK_STREAM;
+		hints.ai_protocol = IPPROTO_TCP;
+
+		struct addrinfo *sock_info;
+		if (getaddrinfo(HDHOMERUN_DEBUG_HOST, HDHOMERUN_DEBUG_PORT, &hints, &sock_info) != 0) {
 			hdhomerun_debug_close_internal(dbg);
 			return FALSE;
 		}
-
-		if (!hdhomerun_sock_connect(dbg->sock, remote_addr, HDHOMERUN_DEBUG_PORT, HDHOMERUN_DEBUG_CONNECT_TIMEOUT)) {
+		if (connect(dbg->sock, sock_info->ai_addr, (int)sock_info->ai_addrlen) != 0) {
+			freeaddrinfo(sock_info);
 			hdhomerun_debug_close_internal(dbg);
 			return FALSE;
 		}
+		freeaddrinfo(sock_info);
 	}
 
 	size_t length = strlen(message->buffer);
-	if (!hdhomerun_sock_send(dbg->sock, message->buffer, length, HDHOMERUN_DEBUG_SEND_TIMEOUT)) {
+	if (send(dbg->sock, (char *)message->buffer, (int)length, 0) != length) {
 		hdhomerun_debug_close_internal(dbg);
 		return FALSE;
 	}
 
 	return TRUE;
 }
+#endif
 
 static bool_t hdhomerun_debug_output_message(struct hdhomerun_debug_t *dbg, struct hdhomerun_debug_message_t *message)
 {
@@ -456,7 +466,7 @@
 		pthread_mutex_unlock(&dbg->queue_lock);
 
 		if (!message) {
-			msleep_approx(250);
+			msleep(250);
 			continue;
 		}
 
@@ -466,7 +476,7 @@
 		}
 
 		if (!hdhomerun_debug_output_message(dbg, message)) {
-			msleep_approx(250);
+			msleep(250);
 			continue;
 		}
 
Index: mythtv/libs/libmythhdhomerun/libmythhdhomerun.pro
===================================================================
--- mythtv/libs/libmythhdhomerun/libmythhdhomerun.pro	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/libmythhdhomerun.pro	(working copy)
@@ -10,33 +10,21 @@
 
 QMAKE_CLEAN += $(TARGET) $(TARGETA) $(TARGETD) $(TARGET0) $(TARGET1) $(TARGET2)
 
-HEADERS += hdhomerun.h  hdhomerun_os.h  hdhomerun_sock.h  hdhomerun_types.h
+HEADERS += hdhomerun.h  hdhomerun_os.h  hdhomerun_types.h
 
 HEADERS += hdhomerun_channels.h  hdhomerun_channelscan.h  hdhomerun_control.h
-HEADERS += hdhomerun_debug.h     hdhomerun_device.h
+HEADERS += hdhomerun_debug.h     hdhomerun_device.h       hdhomerun_dhcp.h
+HEADERS += hdhomerun_discover.h  hdhomerun_pkt.h          hdhomerun_video.h 
 HEADERS += hdhomerun_device_selector.h
-HEADERS += hdhomerun_discover.h  hdhomerun_os_posix.h
-HEADERS += hdhomerun_pkt.h       hdhomerun_video.h 
 
-SOURCES += hdhomerun_config.c
-
 SOURCES += hdhomerun_channels.c  hdhomerun_channelscan.c  hdhomerun_control.c
-SOURCES += hdhomerun_debug.c     hdhomerun_device.c
+SOURCES += hdhomerun_debug.c     hdhomerun_device.c       hdhomerun_dhcp.c
+SOURCES += hdhomerun_discover.c  hdhomerun_pkt.c          hdhomerun_video.c
 SOURCES += hdhomerun_device_selector.c
-SOURCES += hdhomerun_discover.c  hdhomerun_os_posix.c
-SOURCES += hdhomerun_pkt.c       hdhomerun_video.c
 
-
-unix:SOURCES += hdhomerun_sock_posix.c
-
 mingw {
     HEADERS += hdhomerun_os_windows.h
-    SOURCES += hdhomerun_os_windows.c
-    SOURCES -= hdhomerun_os_posix.c
-    SOURCES += hdhomerun_sock_windows.c
     LIBS += -lws2_32 -liphlpapi -lpthread
 }
 
-LIBS += $$EXTRALIBS
-
 include ( ../libs-targetfix.pro )
Index: mythtv/libs/libmythhdhomerun/hdhomerun_config.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_config.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_config.c	(working copy)
@@ -286,7 +286,7 @@
 		}
 
 		cmd_scan_printf(fp, "SCANNING: %lu (%s)\n",
-			(unsigned long)result.frequency, result.channel_str
+			result.frequency, result.channel_str
 		);
 
 		ret = hdhomerun_device_channelscan_detect(hd, &result);
@@ -364,7 +364,7 @@
 		size_t actual_size;
 		uint8_t *ptr = hdhomerun_device_stream_recv(hd, VIDEO_DATA_BUFFER_SIZE_1S, &actual_size);
 		if (!ptr) {
-			msleep_approx(64);
+			msleep(64);
 			continue;
 		}
 
@@ -381,12 +381,6 @@
 				next_progress = loop_start_time + 1000;
 			}
 
-			/* Windows - indicate activity to suppress auto sleep mode. */
-			#if defined(__WINDOWS__)
-			SetThreadExecutionState(ES_SYSTEM_REQUIRED);
-			#endif
-
-			/* Video stats. */
 			hdhomerun_device_get_video_stats(hd, &stats_cur);
 
 			if (stats_cur.overflow_error_count > stats_old.overflow_error_count) {
@@ -410,7 +404,7 @@
 			continue;
 		}
 
-		msleep_approx(delay);
+		msleep(delay);
 	}
 
 	if (fp) {
@@ -446,10 +440,10 @@
 		fclose(fp);
 		return -1;
 	}
-	msleep_minimum(2000);
+	sleep(2);
 
 	printf("upgrading firmware...\n");
-	msleep_minimum(8000);
+	sleep(8);
 
 	printf("rebooting...\n");
 	int count = 0;
@@ -466,7 +460,7 @@
 			return -1;
 		}
 
-		msleep_minimum(1000);
+		sleep(1);
 	}
 
 	printf("upgrade complete - now running firmware %s\n", version_str);
Index: mythtv/libs/libmythhdhomerun/hdhomerun_video.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_video.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_video.c	(working copy)
@@ -34,27 +34,21 @@
 
 struct hdhomerun_video_sock_t {
 	pthread_mutex_t lock;
-	struct hdhomerun_debug_t *dbg;
-
-	int sock;
-	uint32_t multicast_ip;
-
-	volatile size_t head;
-	volatile size_t tail;
 	uint8_t *buffer;
 	size_t buffer_size;
+	volatile size_t head;
+	volatile size_t tail;
 	size_t advance;
-
-	pthread_t thread;
 	volatile bool_t terminate;
-
+	pthread_t thread;
+	int sock;
+	uint32_t rtp_sequence;
+	struct hdhomerun_debug_t *dbg;
 	volatile uint32_t packet_count;
 	volatile uint32_t transport_error_count;
 	volatile uint32_t network_error_count;
 	volatile uint32_t sequence_error_count;
 	volatile uint32_t overflow_error_count;
-
-	volatile uint32_t rtp_sequence;
 	volatile uint8_t sequence[0x2000];
 };
 
@@ -70,7 +64,7 @@
 	}
 
 	vs->dbg = dbg;
-	vs->sock = HDHOMERUN_SOCK_INVALID;
+	vs->sock = -1;
 	pthread_mutex_init(&vs->lock, NULL);
 
 	/* Reset sequence tracking. */
@@ -92,8 +86,8 @@
 	}
 	
 	/* Create socket. */
-	vs->sock = hdhomerun_sock_create_udp();
-	if (vs->sock == HDHOMERUN_SOCK_INVALID) {
+	vs->sock = (int)socket(AF_INET, SOCK_DGRAM, 0);
+	if (vs->sock == -1) {
 		hdhomerun_debug_printf(dbg, "hdhomerun_video_create: failed to allocate socket\n");
 		goto error;
 	}
@@ -102,8 +96,17 @@
 	int rx_size = 1024 * 1024;
 	setsockopt(vs->sock, SOL_SOCKET, SO_RCVBUF, (char *)&rx_size, sizeof(rx_size));
 
+	/* Set timeouts. */
+	setsocktimeout(vs->sock, SOL_SOCKET, SO_SNDTIMEO, 1000);
+	setsocktimeout(vs->sock, SOL_SOCKET, SO_RCVTIMEO, 1000);
+
 	/* Bind socket. */
-	if (!hdhomerun_sock_bind(vs->sock, INADDR_ANY, listen_port)) {
+	struct sockaddr_in sock_addr;
+	memset(&sock_addr, 0, sizeof(sock_addr));
+	sock_addr.sin_family = AF_INET;
+	sock_addr.sin_addr.s_addr = htonl(INADDR_ANY);
+	sock_addr.sin_port = htons(listen_port);
+	if (bind(vs->sock, (struct sockaddr *)&sock_addr, sizeof(sock_addr)) != 0) {
 		hdhomerun_debug_printf(dbg, "hdhomerun_video_create: failed to bind socket (port %u)\n", listen_port);
 		goto error;
 	}
@@ -118,8 +121,8 @@
 	return vs;
 
 error:
-	if (vs->sock != HDHOMERUN_SOCK_INVALID) {
-		hdhomerun_sock_destroy(vs->sock);
+	if (vs->sock != -1) {
+		close(vs->sock);
 	}
 	if (vs->buffer) {
 		free(vs->buffer);
@@ -133,7 +136,7 @@
 	vs->terminate = TRUE;
 	pthread_join(vs->thread, NULL);
 
-	hdhomerun_sock_destroy(vs->sock);
+	close(vs->sock);
 	free(vs->buffer);
 
 	free(vs);
@@ -141,54 +144,16 @@
 
 uint16_t hdhomerun_video_get_local_port(struct hdhomerun_video_sock_t *vs)
 {
-	uint16_t port = hdhomerun_sock_getsockname_port(vs->sock);
-	if (port == 0) {
-		hdhomerun_debug_printf(vs->dbg, "hdhomerun_video_get_local_port: getsockname failed (%d)\n", hdhomerun_sock_getlasterror());
+	struct sockaddr_in sock_addr;
+	socklen_t sockaddr_size = sizeof(sock_addr);
+	if (getsockname(vs->sock, (struct sockaddr*)&sock_addr, &sockaddr_size) != 0) {
+		hdhomerun_debug_printf(vs->dbg, "hdhomerun_video_get_local_port: getsockname failed (%d)\n", sock_getlasterror);
 		return 0;
 	}
 
-	return port;
+	return ntohs(sock_addr.sin_port);
 }
 
-int hdhomerun_video_join_multicast_group(struct hdhomerun_video_sock_t *vs, uint32_t multicast_ip, uint32_t local_ip)
-{
-	if (vs->multicast_ip != 0) {
-		hdhomerun_video_leave_multicast_group(vs);
-	}
-
-	struct ip_mreq imr;
-	memset(&imr, 0, sizeof(imr));
-	imr.imr_multiaddr.s_addr  = htonl(multicast_ip);
-	imr.imr_interface.s_addr  = htonl(local_ip);
-
-	if (setsockopt(vs->sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, (const char *)&imr, sizeof(imr)) != 0) {
-		hdhomerun_debug_printf(vs->dbg, "hdhomerun_video_join_multicast_group: setsockopt failed (%d)\n", hdhomerun_sock_getlasterror());
-		return -1;
-	}
-
-	vs->multicast_ip = multicast_ip;
-	return 1;
-}
-
-int hdhomerun_video_leave_multicast_group(struct hdhomerun_video_sock_t *vs)
-{
-	if (vs->multicast_ip == 0) {
-		return 1;
-	}
-
-	struct ip_mreq imr;
-	memset(&imr, 0, sizeof(imr));
-	imr.imr_multiaddr.s_addr  = htonl(vs->multicast_ip);
-	imr.imr_interface.s_addr  = htonl(INADDR_ANY);
-
-	if (setsockopt(vs->sock, IPPROTO_IP, IP_DROP_MEMBERSHIP, (const char *)&imr, sizeof(imr)) != 0) {
-		hdhomerun_debug_printf(vs->dbg, "hdhomerun_video_leave_multicast_group: setsockopt failed (%d)\n", hdhomerun_sock_getlasterror());
-	}
-
-	vs->multicast_ip = 0;
-	return 1;
-}
-
 static void hdhomerun_video_stats_ts_pkt(struct hdhomerun_video_sock_t *vs, uint8_t *ptr)
 {
 	uint16_t packet_identifier = ((uint16_t)(ptr[1] & 0x1F) << 8) | (uint16_t)ptr[2];
@@ -203,22 +168,23 @@
 		return;
 	}
 
-	uint8_t sequence = ptr[3] & 0x0F;
-
+	uint8_t continuity_counter = ptr[3] & 0x0F;
 	uint8_t previous_sequence = vs->sequence[packet_identifier];
-	vs->sequence[packet_identifier] = sequence;
 
-	if (previous_sequence == 0xFF) {
+	if (continuity_counter == ((previous_sequence + 1) & 0x0F)) {
+		vs->sequence[packet_identifier] = continuity_counter;
 		return;
 	}
-	if (sequence == ((previous_sequence + 1) & 0x0F)) {
+	if (previous_sequence == 0xFF) {
+		vs->sequence[packet_identifier] = continuity_counter;
 		return;
 	}
-	if (sequence == previous_sequence) {
+	if (continuity_counter == previous_sequence) {
 		return;
 	}
 
 	vs->sequence_error_count++;
+	vs->sequence[packet_identifier] = continuity_counter;
 }
 
 static void hdhomerun_video_parse_rtp(struct hdhomerun_video_sock_t *vs, struct hdhomerun_pkt_t *pkt)
@@ -227,27 +193,19 @@
 	uint32_t rtp_sequence = hdhomerun_pkt_read_u16(pkt);
 	pkt->pos += 8;
 
-	uint32_t previous_rtp_sequence = vs->rtp_sequence;
-	vs->rtp_sequence = rtp_sequence;
+	if (rtp_sequence != ((vs->rtp_sequence + 1) & 0xFFFF)) {
+		if (vs->rtp_sequence != 0xFFFFFFFF) {
+			vs->network_error_count++;
 
-	/* Initial case - first packet received. */
-	if (previous_rtp_sequence == 0xFFFFFFFF) {
-		return;
+			/* restart pid sequence check */
+			/* can't use memset bcs sequence is volatile */
+			int i;
+			for (i = 0; i < sizeof(vs->sequence) / sizeof(uint8_t) ; i++)
+				vs->sequence[i] = 0xFF;
+		}
 	}
 
-	/* Normal case - next sequence number. */
-	if (rtp_sequence == ((previous_rtp_sequence + 1) & 0xFFFF)) {
-		return;
-	}
-
-	/* Error case - sequence missed. */
-	vs->network_error_count++;
-
-	/* Restart pid sequence check after packet loss. */
-	int i;
-	for (i = 0; i < 0x2000; i++) {
-		vs->sequence[i] = 0xFF;
-	}
+	vs->rtp_sequence = rtp_sequence;
 }
 
 static THREAD_FUNC_PREFIX hdhomerun_video_thread_execute(void *arg)
@@ -260,11 +218,7 @@
 		hdhomerun_pkt_reset(pkt);
 
 		/* Receive. */
-		size_t length = VIDEO_RTP_DATA_PACKET_SIZE;
-		if (!hdhomerun_sock_recv(vs->sock, pkt->end, &length, 25)) {
-			continue;
-		}
-
+		int length = recv(vs->sock, (char *)pkt->end, VIDEO_RTP_DATA_PACKET_SIZE, 0);
 		pkt->end += length;
 
 		if (length == VIDEO_RTP_DATA_PACKET_SIZE) {
@@ -273,8 +227,16 @@
 		}
 
 		if (length != VIDEO_DATA_PACKET_SIZE) {
-			/* Data received but not valid - ignore. */
-			continue;
+			if (length > 0) {
+				/* Data received but not valid - ignore. */
+				continue;
+			}
+			if (sock_getlasterror_socktimeout) {
+				/* Wait for more data. */
+				continue;
+			}
+			vs->terminate = TRUE;
+			return NULL;
 		}
 
 		pthread_mutex_lock(&vs->lock);
@@ -307,6 +269,7 @@
 			continue;
 		}
 
+		/* Atomic update. */
 		vs->head = head;
 
 		pthread_mutex_unlock(&vs->lock);
@@ -328,6 +291,7 @@
 			tail -= vs->buffer_size;
 		}
 	
+		/* Atomic update. */
 		vs->tail = tail;
 	}
 
@@ -370,12 +334,13 @@
 	vs->tail = vs->head;
 	vs->advance = 0;
 
-	vs->rtp_sequence = 0xFFFFFFFF;
+	/* can't use memset bcs sequence is volatile */
 	int i;
-	for (i = 0; i < 0x2000; i++) {
+	for (i = 0; i < sizeof(vs->sequence) / sizeof(uint8_t) ; i++)
 		vs->sequence[i] = 0xFF;
-	}
 
+	vs->rtp_sequence = 0xFFFFFFFF;
+
 	vs->packet_count = 0;
 	vs->transport_error_count = 0;
 	vs->network_error_count = 0;
@@ -390,10 +355,10 @@
 	struct hdhomerun_video_stats_t stats;
 	hdhomerun_video_get_stats(vs, &stats);
 
-	hdhomerun_debug_printf(vs->dbg, "video sock: pkt=%lu net=%lu te=%lu miss=%lu drop=%lu\n",
-		(unsigned long)stats.packet_count, (unsigned long)stats.network_error_count,
-		(unsigned long)stats.transport_error_count, (unsigned long)stats.sequence_error_count,
-		(unsigned long)stats.overflow_error_count
+	hdhomerun_debug_printf(vs->dbg, "video sock: pkt=%ld net=%ld te=%ld miss=%ld drop=%ld\n",
+		stats.packet_count, stats.network_error_count,
+		stats.transport_error_count, stats.sequence_error_count,
+		stats.overflow_error_count
 	);
 }
 
Index: mythtv/libs/libmythhdhomerun/hdhomerun_os_posix.h
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_os_posix.h	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_os_posix.h	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_os_posix.h
  *
- * Copyright © 2006-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2006-2008 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -52,18 +52,44 @@
 typedef int bool_t;
 
 #define LIBTYPE
+#define sock_getlasterror errno
+#define sock_getlasterror_socktimeout (errno == EAGAIN)
 #define console_vprintf vprintf
 #define console_printf printf
 #define THREAD_FUNC_PREFIX void *
 
-#ifdef __cplusplus
-extern "C" {
-#endif
+static inline uint64_t getcurrenttime(void)
+{
+	struct timeval t;
+	gettimeofday(&t, NULL);
+	return ((uint64_t)t.tv_sec * 1000) + (t.tv_usec / 1000);
+}
 
-extern LIBTYPE uint64_t getcurrenttime(void);
-extern LIBTYPE void msleep_approx(uint64_t ms);
-extern LIBTYPE void msleep_minimum(uint64_t ms);
+static inline int msleep(unsigned int ms)
+{
+	uint64_t stop_time = getcurrenttime() + ms;
 
-#ifdef __cplusplus
+	while (1) {
+		uint64_t current_time = getcurrenttime();
+		if (current_time >= stop_time) {
+			return 0;
+		}
+
+		uint64_t delay_s = (stop_time - current_time) / 1000;
+		if (delay_s > 0) {
+			sleep((unsigned int)delay_s);
+			continue;
+		}
+
+		uint64_t delay_us = (stop_time - current_time) * 1000;
+		usleep((unsigned int)delay_us);
+	}
 }
-#endif
+
+static inline int setsocktimeout(int s, int level, int optname, uint64_t timeout)
+{
+	struct timeval t;
+	t.tv_sec = timeout / 1000;
+	t.tv_usec = (timeout % 1000) * 1000;
+	return setsockopt(s, level, optname, (char *)&t, sizeof(t));
+}
Index: mythtv/libs/libmythhdhomerun/hdhomerun_video.h
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_video.h	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_video.h	(working copy)
@@ -71,12 +71,6 @@
 extern LIBTYPE uint16_t hdhomerun_video_get_local_port(struct hdhomerun_video_sock_t *vs);
 
 /*
- * Join/leave multicast group.
- */
-extern LIBTYPE int hdhomerun_video_join_multicast_group(struct hdhomerun_video_sock_t *vs, uint32_t multicast_ip, uint32_t local_ip);
-extern LIBTYPE int hdhomerun_video_leave_multicast_group(struct hdhomerun_video_sock_t *vs);
-
-/*
  * Read data from buffer.
  *
  * size_t max_size: The maximum amount of data to be returned.
Index: mythtv/libs/libmythhdhomerun/hdhomerun_channelscan.c
===================================================================
--- mythtv/libs/libmythhdhomerun/hdhomerun_channelscan.c	(revision 24016)
+++ mythtv/libs/libmythhdhomerun/hdhomerun_channelscan.c	(working copy)
@@ -1,7 +1,7 @@
 /*
  * hdhomerun_channelscan.c
  *
- * Copyright © 2007-2010 Silicondust USA Inc. <www.silicondust.com>.
+ * Copyright © 2007-2008 Silicondust USA Inc. <www.silicondust.com>.
  *
  * This library is free software; you can redistribute it and/or 
  * modify it under the terms of the GNU Lesser General Public
@@ -99,7 +99,7 @@
 			return 1;
 		}
 
-		msleep_approx(250);
+		msleep(250);
 	}
 }
 
@@ -303,7 +303,7 @@
 			break;
 		}
 
-		msleep_approx(250);
+		msleep(250);
 	}
 
 	/* Lock => skip overlapping channels. */
